
void _efl_threadio_indata_set(Eo *obj, Efl_ThreadIO_Data *pd, void *data);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_threadio_indata_set, EFL_FUNC_CALL(data), void *data);

void *_efl_threadio_indata_get(const Eo *obj, Efl_ThreadIO_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_threadio_indata_get, void *, NULL);

void _efl_threadio_outdata_set(Eo *obj, Efl_ThreadIO_Data *pd, void *data);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_threadio_outdata_set, EFL_FUNC_CALL(data), void *data);

void *_efl_threadio_outdata_get(const Eo *obj, Efl_ThreadIO_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_threadio_outdata_get, void *, NULL);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_threadio_call, EFL_FUNC_CALL(func_data, func, func_free_cb), void *func_data, EflThreadIOCall func, Eina_Free_Cb func_free_cb);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_threadio_call_sync, void *, NULL, EFL_FUNC_CALL(func_data, func, func_free_cb), void *func_data, EflThreadIOCallSync func, Eina_Free_Cb func_free_cb);

static Eina_Bool
_efl_threadio_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_THREADIO_EXTRA_OPS
#define EFL_THREADIO_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_threadio_indata_set, _efl_threadio_indata_set),
      EFL_OBJECT_OP_FUNC(efl_threadio_indata_get, _efl_threadio_indata_get),
      EFL_OBJECT_OP_FUNC(efl_threadio_outdata_set, _efl_threadio_outdata_set),
      EFL_OBJECT_OP_FUNC(efl_threadio_outdata_get, _efl_threadio_outdata_get),
      EFL_OBJECT_OP_FUNC(efl_threadio_call, NULL),
      EFL_OBJECT_OP_FUNC(efl_threadio_call_sync, NULL),
      EFL_THREADIO_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_threadio_class_desc = {
   EO_VERSION,
   "Efl.ThreadIO",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_ThreadIO_Data),
   _efl_threadio_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_threadio_mixin_get, &_efl_threadio_class_desc, NULL, NULL);
